#ifndef HTMLSYNTAXCOLOR
#define HTMLSYNTAXCOLOR

#include <SupportKit.h>
#include "SyntaxColorer.h"

#define TAG			0
#define COMMENT		1
#define ERROR		2
#define	TEXT		3

#define	TAG_BEGIN		0
#define TAG_END			1
#define COMMENT_BEGIN	2
#define COMMENT_END		3

#define TAGHANDLER			0
#define COMMENTHANDLER		1
#define TEXTHANDLER			2

class	TextBlock
{
public:
	bool	m_Dirty;
	int		m_Start;
	int		m_Stop;
	int		m_Type;			//Tag/Comment/Error/Text
};




class HtmlSyntaxColorer : public SyntaxColorer
{
public:
	HtmlSyntaxColorer();
	~HtmlSyntaxColorer();
	
	bool	HandlesType(const char* Mimetype);

	void	ReparseAll(const char* Text);
	void	ReparseAllNew(const char* Text);

	void	TextInserted(int Offset,int Length,const char* Text);
	void	TextDeleted(int Start,int Stop,const char* Text);

	void	InitColorGet();
	bool	GetColorRange(int &Start,int &Stop,rgb_color &Color);

protected:
	void	AddItem(int Start,int Stop,int Type);
private:
	int		m_ListPos;
	int		m_Mode;
	int		m_Offset;
	
	const char*	m_Text;

	BList	m_TextList;	
};



#endif